using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BeyondBasicUnitTesting.Business
{
    public class PersonFacade3 : IPersonFacade
    {
        public PersonFacade3(ILogger logger, IRepository<IPerson> personRepository)
        {
            if (logger == null)
            {
                throw new ArgumentNullException("logger", "Argument cannot be null.");
            }

            if (personRepository == null)
            {
                throw new ArgumentNullException("personRepository", "Argument cannot be null.");
            }

            m_loggerInstance = logger;
            m_personRepository = personRepository;
        }

        private ILogger m_loggerInstance;
        protected ILogger LoggerInstance
        {
            get { return m_loggerInstance; }
        }

        private IRepository<IPerson> m_personRepository;
        protected IRepository<IPerson> PersonRepository
        {
            get { return m_personRepository; }
        }

        public bool IsPersonValid(IPerson checkThis)
        {
            if (checkThis == null)
            {
                return false;
            }
            else
            {
                if (checkThis.FirstName == null || checkThis.LastName == null || checkThis.EmailAddress == null || checkThis.Status == null)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            }
        }

        public void SavePerson(IPerson saveThis)
        {
            try
            {
                if (IsPersonValid(saveThis) == false)
                {
                    throw new InvalidOperationException("Person cannot be saved because it is invalid.");
                }
                else 
                {
                    //saveThis.Id = new Random().Next(1, Int32.MaxValue);
                    PersonRepository.Save(saveThis);
                }
            }
            catch (Exception ex)
            {
                //new Logger().WriteToLog(ex.ToString());
                LoggerInstance.WriteToLog(ex.ToString());
                throw;
            }
        }

        public IPerson GetById(int personId)
        {
            return PersonRepository.GetById(personId);
        }

        public IList<IPerson> GetAll()
        {
            return PersonRepository.GetAll();
        }
    }
}
