﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WebUI
{
    public class DemoSession
    {
        private const string SessionKeyName = "DemoSession";
        private DemoSession(IRepository<IPerson> repository, ILogger logger)
        {
            m_personRepositoryInstance = repository;
            m_loggerInstance = logger;
        }

        private IRepository<IPerson> m_personRepositoryInstance;
        public IRepository<IPerson> PersonRepositoryInstance
        {
            get { return m_personRepositoryInstance; }
        }

        private ILogger m_loggerInstance;
        public ILogger LoggerInstance
        {
            get
            {
                return m_loggerInstance;
            }
        }

        public static void Reset()
        {
            HttpContext.Current.Session[SessionKeyName] = null;
        }

        public static DemoSession GetCurrent()
        {
            DemoSession current;

            current = HttpContext.Current.Session[SessionKeyName] as DemoSession;

            if (current == null)
            {
                current = new DemoSession(new RepositoryMock<IPerson>(), new Logger());

                HttpContext.Current.Session[SessionKeyName] = current;
            }

            return current;
        }
    }
}
