﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WebUI.After
{
    public partial class PersonDetailView : BasePage, IPersonDetailView
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (this.IsPostBack == false)
            {
                int id = WebUiUtility.ParseInt32(Request["Id"], 0);

                if (id == -1)
                {
                    PersonPresenterInstance.InitializeBlank(this);
                }
                else
                {
                    this.PersonId = id;
                    PersonPresenterInstance.LoadById(this);
                }
            }
        }

        public int PersonId
        {
            get
            {
                return WebUiUtility.GetValueAsInt32(m_labelId);
            }
            set
            {
                WebUiUtility.SetValue(m_labelId, value);
            }
        }


        public string FirstName
        {
            get
            {
                return WebUiUtility.GetValue(m_textFirstName);
            }
            set
            {
                WebUiUtility.SetValue(m_textFirstName, value);
            }
        }

        public string LastName
        {
            get
            {
                return WebUiUtility.GetValue(m_textLastName);
            }
            set
            {
                WebUiUtility.SetValue(m_textLastName, value);
            }
        }

        public string EmailAddress
        {
            get
            {
                return WebUiUtility.GetValue(m_textEmailAddress);
            }
            set
            {
                WebUiUtility.SetValue(m_textEmailAddress, value);
            }
        }

        public string Status
        {
            get
            {
                if (m_chkIsActive.Checked == true)
                {
                    return "ACTIVE";
                }
                else
                {
                    return "INACTIVE";
                }
            }
            set
            {
                if (value == null || value != "ACTIVE")
                {
                    m_chkIsActive.Checked = false;
                }
                else
                {
                    m_chkIsActive.Checked = true;
                }
            }
        }

        protected void m_btnSave_Click(object sender, EventArgs e)
        {
            try
            {
                PersonPresenterInstance.Save(this);

                WebUiUtility.AddMessage(this.Page, "Saved.");
            }
            catch (Exception ex)
            {
                WebUiUtility.AddMessage(this.Page, ex);
            }
        }

        protected void m_btnCancel_Click(object sender, EventArgs e)
        {
            Response.Redirect("~/After/PersonSearchView.aspx");
        }
    }
}
