﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WebUI.Before
{
    public partial class PersonDetail : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (this.IsPostBack == false)
            {
                int id = -1;

                id = WebUiUtility.ParseInt32(Request["id"], -1);

                if (id == -1)
                {
                    m_labelId.Text = id.ToString();
                    m_textEmailAddress.Text = "";
                    m_textFirstName.Text = "";
                    m_textLastName.Text = "";
                    m_chkIsActive.Checked = true;
                }
                else
                {
                    IPersonFacade facade = new PersonFacade(
                            DemoSession.GetCurrent().LoggerInstance,
                            DemoSession.GetCurrent().PersonRepositoryInstance);

                    IPerson person = facade.GetById(id);

                    m_labelId.Text = person.Id.ToString();
                    m_textEmailAddress.Text = person.EmailAddress;
                    m_textFirstName.Text = person.FirstName;
                    m_textLastName.Text = person.LastName;

                    if (person.Status == "ACTIVE")
                    {
                        m_chkIsActive.Checked = true;
                    }
                    else
                    {
                        m_chkIsActive.Checked = false;
                    }
                }
            }
        }

        protected void m_btnSave_Click(object sender, EventArgs e)
        {
            try
			{
				IPerson person;

                IPersonFacade facade = new PersonFacade(
                    DemoSession.GetCurrent().LoggerInstance,
                    DemoSession.GetCurrent().PersonRepositoryInstance);

				if (m_labelId.Text == "-1")
				{
					// create new
					person = new Person();
				}
				else
				{
					person = facade.GetById(WebUiUtility.ParseInt32(m_labelId.Text, -1));

					if (person == null)
					{
						throw new InvalidOperationException("Invalid id.");
					}
				}

				person.EmailAddress = m_textEmailAddress.Text;
				person.FirstName = m_textFirstName.Text;
				person.LastName = m_textLastName.Text;

				if (m_chkIsActive.Checked == true)
				{
					person.Status = "ACTIVE";
				}
				else
				{
					person.Status = "INACTIVE";
				}

				facade.SavePerson(person);

				m_labelId.Text = person.Id.ToString();

                WebUiUtility.AddMessage(this, "Saved.");
			}
            catch (Exception ex)
            {
                WebUiUtility.AddMessage(this, ex);
            }
        }

        protected void m_btnCancel_Click(object sender, EventArgs e)
        {
            Response.Redirect("PersonSearch.aspx");
        }
    }
}
