﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WinUI.After
{
    public partial class PersonDetail : BaseForm, IPersonDetailView
    {
        public PersonDetail()
        {
            InitializeComponent();
        }

        private void m_btnSave_Click(object sender, EventArgs e)
        {
            try
            {
                PersonPresenterInstance.Save(this);

                m_status.Text = "Saved.";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            } 
        }

        private void m_btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void PersonDetail_Load(object sender, EventArgs e)
        {
            int id = this.PersonId;

            if (id == -1)
            {
                PersonPresenterInstance.InitializeBlank(this);
            }
            else
            {
                this.PersonId = id;
                PersonPresenterInstance.LoadById(this);
            }
        }

        public int PersonId
        {
            get
            {
                return UiUtility.GetValueAsInt32(m_labelId);
            }
            set
            {
                UiUtility.SetValue(m_labelId, value);
            }
        }


        public string FirstName
        {
            get
            {
                return UiUtility.GetValue(m_textFirstName);
            }
            set
            {
                UiUtility.SetValue(m_textFirstName, value);
            }
        }

        public string LastName
        {
            get
            {
                return UiUtility.GetValue(m_textLastName);
            }
            set
            {
                UiUtility.SetValue(m_textLastName, value);
            }
        }

        public string EmailAddress
        {
            get
            {
                return UiUtility.GetValue(m_textEmailAddress);
            }
            set
            {
                UiUtility.SetValue(m_textEmailAddress, value);
            }
        }

        public string Status
        {
            get
            {
                if (m_chkIsActive.Checked == true)
                {
                    return "ACTIVE";
                }
                else
                {
                    return "INACTIVE";
                }
            }
            set
            {
                if (value == null || value != "ACTIVE")
                {
                    m_chkIsActive.Checked = false;
                }
                else
                {
                    m_chkIsActive.Checked = true;
                }
            }
        }
    }
}
