﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WinUI
{
    public class DemoSession
    {
        private static DemoSession m_current;

        private DemoSession(IRepository<IPerson> repository, ILogger logger)
        {
            m_personRepositoryInstance = repository;
            m_loggerInstance = logger;
        }

        private IRepository<IPerson> m_personRepositoryInstance;
        public IRepository<IPerson> PersonRepositoryInstance
        {
            get { return m_personRepositoryInstance; }
        }

        private ILogger m_loggerInstance;
        public ILogger LoggerInstance
        {
            get
            {
                return m_loggerInstance;
            }
        }

        public static void Reset()
        {
            m_current = null;
        }

        public static DemoSession GetCurrent()
        {
            DemoSession current;

            current = m_current;

            if (current == null)
            {
                current = new DemoSession(new RepositoryMock<IPerson>(), new Logger());

                m_current = current;
            }

            return current;
        }
    }
}
