﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using BeyondBasicUnitTesting.Business;

namespace BeyondBasicUnitTesting.WinUI
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void m_btnRunBefore_Click(object sender, EventArgs e)
        {
            try
            {
                BeyondBasicUnitTesting.WinUI.Before.PersonSearch editor = 
                    new BeyondBasicUnitTesting.WinUI.Before.PersonSearch();

                editor.Show();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            } 
        }

        private void m_btnRunAfter_Click(object sender, EventArgs e)
        {
            try
            {
                BeyondBasicUnitTesting.WinUI.After.PersonSearch editor =
                    new BeyondBasicUnitTesting.WinUI.After.PersonSearch();

                editor.Show();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void m_btnCreateTestData_Click(object sender, EventArgs e)
        {
            try
            {
                IPersonFacade facade = new PersonFacade(
                    DemoSession.GetCurrent().LoggerInstance,
                    DemoSession.GetCurrent().PersonRepositoryInstance);

                facade.SavePerson(facade.Create("Grant", "Achatz", "grant@alinea.com", "ACTIVE"));
                facade.SavePerson(facade.Create("Thomas", "Keller", "t.keller@frenchlaundry.com", "ACTIVE"));
                facade.SavePerson(facade.Create("Tony", "Maws", "tony@craigieonmain.com", "ACTIVE"));
                facade.SavePerson(facade.Create("Michael", "Schlow", "shlow@viamattarestaurant.com", "ACTIVE"));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void m_btnResetSession_Click(object sender, EventArgs e)
        {
            DemoSession.Reset();
        }
    }
}
